<template>
  <div class="frame frame-bg-02">
    <div class="center menu-icon" @click='change' @click.once="noAnimate">
      <div class="line" :class="classObject1"></div>
      <div class="line margin-between-lines" :class="classObject2"></div>
      <div class="line margin-between-lines" :class="classObject3"></div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'Day02',
  data () {
    return {
      isOpen: false,
      animation: true
    }
  },
  methods: {
    change() {
      this.isOpen = !this.isOpen
    },
    noAnimate() {
      this.animation = !this.isOpen
    }
  },
  computed: {
    classObject1() {
      return {
        'line1': this.isOpen,
        'line1-active': !this.isOpen,
        'no-animate': this.animation
      }
    },
    classObject2() {
      return {
        'line2': this.isOpen,
        'line2-active': !this.isOpen,
        'no-animate': this.animation
      }
    },
    classObject3() {
      return {
        'line3': this.isOpen,
        'line3-active': !this.isOpen,
        'no-animate': this.animation
      }
    }
  }
}
</script>

<style>
.frame-bg-02 {
  background-color: lightcoral;
}

/* Declaring CSS Variables*/
:root {
  --margin-between-lines: 20px;
  --animation-delay: 0.7s;
  --menu-icon-line-height: 4px;
}

.no-animate {
  animation: none !important;
}

.menu-icon {
  cursor: pointer;
}

.line {
  width: 5em;
  border: var(--menu-icon-line-height) solid white;
  background-color: white;
  border-radius: 10px;
}

.margin-between-lines {
  margin: var(--margin-between-lines) 0 0 0;
}

.line1 {
  position: relative;
  animation: animate-line-1-rev var(--animation-delay) ease-in-out;
}

.line2 {
  animation: animate-line-2-rev var(--animation-delay) ease-in-out;
}

.line3 {
  animation: animate-line-3-rev var(--animation-delay) ease-in-out;
}

.line1-active {
  position: relative;
  animation: animate-line-1 var(--animation-delay);
  animation-fill-mode: forwards; 
}

.line2-active {
  animation: animate-line-2 var(--animation-delay);
  animation-fill-mode: forwards; 
}

.line3-active {
  animation: animate-line-3 var(--animation-delay);
  animation-fill-mode: forwards; 
}

/* Primera animación */
@keyframes animate-line-1 {
  0% {
    opacity: 1;
  }
  50% {
    transform: translate3d(0,calc(var(--margin-between-lines) + var(--menu-icon-line-height)*2),0);
  }
  100% {
    transform: translate3d(0,calc(var(--margin-between-lines) + var(--menu-icon-line-height)*2),0) rotate(45deg);
  }
}

@keyframes animate-line-2 {
  0% {
    transform: scale(1);
    opacity: 1;
  }
  100% {
    transform: scale(0);
    opacity:0;
 }
}

@keyframes animate-line-3 {
 0% {
    opacity: 1;
  }
  50% {
    transform: translate3d(0,calc((var(--margin-between-lines) + var(--menu-icon-line-height)*2)*(-1)),0);
  }
  100% {
    transform: translate3d(0,calc((var(--margin-between-lines) + var(--menu-icon-line-height)*2)*(-1)),0) rotate(-45deg);
  }
}

/* Segunda animación */
@keyframes animate-line-2-rev {
  0% {
    opacity: 0;
    transform: scale(0);
  }
  100% {
    opacity: 1;
    transform: scale(1);
 }
}

@keyframes animate-line-1-rev {
  0% {
    transform: translate3d(0,calc(var(--margin-between-lines) + var(--menu-icon-line-height)*2),0) rotate(-45deg);
  }
  50% {
    transform: translate3d(0,calc(var(--margin-between-lines) + var(--menu-icon-line-height)*2),0) rotate(0deg);
  }
  100% {
    transform: translate3d(0,0,0);
  }
}

@keyframes animate-line-3-rev {
  0% {
    transform: translate3d(0,calc((var(--margin-between-lines) + var(--menu-icon-line-height)*2)*(-1)),0) rotate(45deg);
    }
  50% {
    transform: translate3d(0,calc((var(--margin-between-lines) + var(--menu-icon-line-height)*2)*(-1)),0) rotate(0deg);
  }
  100% {
    transform: translate3d(0,0,0);
  }
}
</style>
